function x=idwtcoif12(y)
% inverse discrete wavelet trafo coiflet 12
[n,k]=size(y);
if(n==4) 
  x=y; 
else
 x=zeros(size(y));
 if(k==1)
    s = 1.910297278*idwtcoif12(y(1:(n/2))); %/0.7403107249; 
    d = y(((n/2)+1):n)/1.910297278; % 1.350784159;
    d = d + 12.46443692*cpv(s,-1);
    s = s + 0.02528002562*cpv(d,1)+0.02182215161*cpv(d,2);
    d = d - 9.491856450*cpv(s,-1)+2.017253240*s;
    s = s - 1.479728699*cpv(d,-1)-0.3648016173*d;
    d = d - 0.1023563847*s-0.4940618204*cpv(s,1);  
    s = s + 0.4865531265*cpv(d,-1)-0.3418203790*d;
    d = d + 0.3952094886*s;
	x(2:2:n) = d;
    x(1:2:(n-1))= s;
 else
    s = 1.910297278*idwtcoif12(y(1:(n/2),:)); %/0.7403107249; 
    d = y(((n/2)+1):n,:)/1.910297278; %1.350784159/sqrt(2);
    d = d + 12.46443692*cpv(s,-1);
    s = s + 0.02528002562*cpv(d,1)+0.02182215161*cpv(d,2);
    d = d - 9.491856450*cpv(s,-1)+2.017253240*s;
    s = s - 1.479728699*cpv(d,-1)-0.3648016173*d;
    d = d - 0.1023563847*s-0.4940618204*cpv(s,1);  
    s = s + 0.4865531265*cpv(d,-1)-0.3418203790*d;
    d = d + 0.3952094886*s;
	x(2:2:n,:) = d;
    x(1:2:(n-1),:)= s;
 end
end
end
